var Consumable, EventEmitter, fs,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

EventEmitter = require('events').EventEmitter;

fs = require('fs');

module.exports = Consumable = (function(_super) {
  __extends(Consumable, _super);

  Consumable.fromFile = function(src, endian) {
    var raw;
    raw = fs.readFileSync(src);
    return new Consumable(raw, endian);
  };

  function Consumable(buffer, endian) {
    this.buffer = buffer;
    if (endian == null) {
      endian = 'BE';
    }
    this.char = __bind(this.char, this);
    this._read = __bind(this._read, this);
    this.move = __bind(this.move, this);
    this.read = __bind(this.read, this);
    this.offset = 0;
    this.byte = this._read("UInt8", 1);
    this.int16 = this._read("Int16" + endian, 2);
    this.uint16 = this._read("UInt16" + endian, 2);
    this.int32 = this._read("Int32" + endian, 4);
    this.uint32 = this._read("UInt32" + endian, 4);
    this.float = this._read("Float" + endian, 4);
    this.double = this._read("Double" + endian, 8);
  }

  Consumable.prototype.read = function(n) {
    this.offset += n;
    return this.buffer.slice(this.offset - n, this.offset);
  };

  Consumable.prototype.move = function(n) {
    return this.offset += n;
  };

  Consumable.prototype._read = function(type, delta) {
    var methodName,
      _this = this;
    methodName = "read" + type;
    return function() {
      var value;
      value = _this.buffer[methodName](_this.offset);
      _this.offset += delta;
      return value;
    };
  };

  Consumable.prototype.char = function(n) {
    if (n == null) {
      n = 1;
    }
    return (this.read(n)).toString('ascii');
  };

  return Consumable;

})(EventEmitter);
