var EventEmitter, STATUS, SocksProxy, net, socks,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

net = require('net');

EventEmitter = require('events').EventEmitter;

socks = require('../socks');

STATUS = require('../socks/const').STATUS;

module.exports = SocksProxy = (function(_super) {
  __extends(SocksProxy, _super);

  function SocksProxy(dispatcher, listenPort, listenHost) {
    var _this = this;
    SocksProxy.__super__.constructor.apply(this, arguments);
    this.server = socks.createServer(function(clientConnection, host, port, handshake) {
      var localAddress, serverConnection, _responded;
      localAddress = dispatcher.dispatch();
      serverConnection = net.createConnection({
        host: host,
        port: port,
        localAddress: localAddress
      });
      _responded = false;
      serverConnection.on('connect', function() {
        _responded = true;
        return handshake(STATUS.SUCCESS);
      }).on('error', function(err) {
        if (!_responded) {
          _responded = true;
          switch (err.code) {
            case 'EHOSTUNREACH':
              return handshake(STATUS.HOST_UNREACHABLE);
            case 'ECONNREFUSED':
              return handshake(STATUS.CONNECTION_REFUSED);
            case 'ENETUNREACH':
              return handshake(STATUS.NETWORK_UNREACHABLE);
            default:
              return handshake(STATUS.SERVER_FAILURE);
          }
        }
      }).on('end', function() {
        return dispatcher.free(localAddress);
      });
      clientConnection.pipe(serverConnection);
      serverConnection.pipe(clientConnection);
      return _this.emit('request', {
        serverConnection: serverConnection,
        clientConnection: clientConnection,
        host: host,
        port: port,
        localAddress: localAddress
      });
    });
    this.server.on('error', function(err) {
      return _this.emit('error', err);
    });
    this.server.on('clientError', function(err, data) {
      return _this.emit('clientError', err, data);
    });
    this.server.listen(listenPort, listenHost);
  }

  return SocksProxy;

})(EventEmitter);
